<template lang="pug">
ul.pagination(:class="containerClass")
  li.pagination__item.prev(
    v-if="!(firstPageSelected && hidePrevNext)"
    :class="[prevClass, firstPageSelected ? disabledClass : '']"
    :tabindex="firstPageSelected ? -1 : 0"
  )
    span(
      v-html="prevText || $t('pagination.previous')"
      @click="prevPage()"
      @keyup.enter="prevPage()"
    )

  li.pagination__item(v-for="page in pages")
    span.separator(v-if="page.breakView" tabindex="0")
      slot(name="breakViewContent") {{ breakViewText }}
    a(
      v-else-if="page.disabled"
      :class="[pageClass, page.selected ? activeClass : '', page.disabled ? disabledClass : '', page.breakView ? breakViewClass: '']"
      tabindex="0"
    ) {{ page.content }}
    nuxt-link(
      :to="{ query: Object.assign({}, query, { page: page.index === 0 ? undefined : page.index + 1 }) }"
      v-else
      @click.prevent.native="handlePageSelected(page.index + 1)"
      @keyup.enter.prevent.native="handlePageSelected(page.index + 1)"
      :class="[pageClass, page.selected ? activeClass : '', page.disabled ? disabledClass : '', page.breakView ? breakViewClass: '']"
      replace
      tabindex="0"
    ) {{ page.content }}

  li.pagination__item.last(
    v-if="!(lastPageSelected && hidePrevNext)"
    :class="[nextClass, lastPageSelected ? disabledClass : '']"
    :tabindex="lastPageSelected ? -1 : 0"
  )
    span(
      v-html="nextText || $t('pagination.next')"
      @click="nextPage()"
      @keyup.enter="nextPage()"
    )
</template>

<script>
export default {
  name: 'Pagination',

  beforeUpdate () {
    if (this.forcePage === null) return
    if (this.forcePage !== this.selected) {
      this.selected = this.forcePage
    }
  },

  computed: {
    selected () {
      return this.value
    },
    pages () {
      const items = {}
      if (this.pageCount <= this.pageRange) {
        for (let index = 0; index < this.pageCount; index++) {
          items[index] = {
            index: index,
            content: index + 1,
            selected: index === (this.selected - 1)
          }
        }
      } else {
        const halfPageRange = Math.floor(this.pageRange / 2)

        const setPageItem = index => {
          items[index] = {
            index: index,
            content: index + 1,
            selected: index === (this.selected - 1)
          }
        }

        const setBreakView = index => {
          items[index] = {
            disabled: true,
            breakView: true
          }
        }

        // 1st - loop thru low end of margin pages
        for (let i = 0; i < this.marginPages; i++) {
          setPageItem(i)
        }

        // 2nd - loop thru selected range
        let selectedRangeLow = 0
        if (this.selected - halfPageRange > 0) {
          selectedRangeLow = this.selected - 1 - halfPageRange
        }

        let selectedRangeHigh = selectedRangeLow + this.pageRange - 1
        if (selectedRangeHigh >= this.pageCount) {
          selectedRangeHigh = this.pageCount - 1
          selectedRangeLow = selectedRangeHigh - this.pageRange + 1
        }

        for (let i = selectedRangeLow; i <= selectedRangeHigh && i <= this.pageCount - 1; i++) {
          setPageItem(i)
        }

        // Check if there is breakView in the left of selected range
        if (selectedRangeLow > this.marginPages) {
          setBreakView(selectedRangeLow - 1)
        }

        // Check if there is breakView in the right of selected range
        if (selectedRangeHigh + 1 < this.pageCount - this.marginPages) {
          setBreakView(selectedRangeHigh + 1)
        }

        // 3rd - loop thru high end of margin pages
        for (let i = this.pageCount - 1; i >= this.pageCount - this.marginPages; i--) {
          setPageItem(i)
        }
      }
      return items
    }
  },

  methods: {
    handlePageSelected (selected) {
      if (this.selected === selected) return

      this.$emit('input', selected)
      this.clickHandler(selected)
    },
    prevPage () {
      if (this.selected <= 1) return

      this.$emit('input', this.selected - 1)
      this.clickHandler(this.selected - 1)
    },
    nextPage () {
      if (this.selected >= this.pageCount) return

      this.$emit('input', this.selected + 1)
      this.clickHandler(this.selected + 1)
    },
    firstPageSelected () {
      return this.selected === 1
    },
    lastPageSelected () {
      return (this.selected === this.pageCount) || (this.pageCount === 0)
    }
  },

  props: {
    value: {
      type: Number,
      required: true,
      default: 1
    },
    pageCount: {
      type: Number,
      required: true
    },
    forcePage: {
      type: [Number, null],
      required: false,
      default: null
    },
    clickHandler: {
      type: Function,
      required: false,
      default: () => {}
    },
    pageRange: {
      type: Number,
      required: false,
      default: 3
    },
    marginPages: {
      type: Number,
      required: false,
      default: 1
    },
    prevText: {
      type: String,
      required: false,
      default: ''
    },
    nextText: {
      type: String,
      required: false,
      default: ''
    },
    breakViewText: {
      type: String,
      required: false,
      default: '…'
    },
    containerClass: {
      type: String,
      required: false,
      default: ''
    },
    query: {
      type: Object,
      required: true
    },
    pageClass: {
      type: String,
      required: false,
      default: ''
    },
    prevClass: {
      type: String,
      required: false,
      default: ''
    },
    nextClass: {
      type: String,
      required: false,
      default: ''
    },
    breakViewClass: {
      type: String,
      required: false,
      default: ''
    },
    activeClass: {
      type: String,
      required: false,
      default: 'active'
    },
    disabledClass: {
      type: String,
      required: false,
      default: 'disabled'
    },
    hidePrevNext: {
      type: Boolean,
      required: false,
      default: false
    }
  }
}
</script>
